#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

int *input(int n){
    int *x = new int[n];
    for(int i = 0; i < n; i++)
        scanf("%d", x + i);
    return x;
}

vector<int> copy(int n, int *x){
    vector<int> y(n);
    for(int i = 0; i < n; i++)
        y[i] = x[i];
    return y;
}

void output(int n, int *x){
    for(int i = 0; i < n; i++)
        printf("%d ", x[i]);
}

void output(vector<int> x){
    for(int i = 0; i < x.size(); i++)
        printf("%d ", x[i]);
}

bool *init(int n){
    bool *x = new bool[n];
    for(int i = 0; i < n; i++)
        x[i] = true;
    return x;
}

void qSort(int p, int q, vector<int> &x){
    int i = p, j = q, pivot = x[(p+q)/2];
    while(i <= j){
        for(; x[i] < pivot; i++);
        for(; x[j] > pivot; j--);
        if(i <= j){
            swap(x[i], x[j]);
            i++;
            j--;
        }
    }
    if(p < j)
        qSort(p, j, x);
    if(i < q)
        qSort(i, q, x);
}

int min(vector<int> &x){
    int a = x[0];
    x.erase(x.begin());
    return a;
}

int binary(vector<int> &x, int k){
    if(x[0] == k)
        return 0;
        int p = 0, q = x.size() - 1;
    while(p <= q){
        int s = (p + q)/2;
        if(x[s] > k)
            q = s;
        if(x[s] < k)
            p = s;
        if(x[s] == k)
            return s;
    }
    return -1;
}

int main(){
    int n, m, *b, *a;
    cin >> n;
    a = new int[n];
    m = n*(n + 1)/2;
    b = input(m);
    vector<int> c(copy(m, b));
    qSort(0, m - 1, c);

    for(int i = 0; i < n; i++){
        a[i] = min(c);
        for(int j = 0; j < i; j++)
            c.erase(c.begin() + binary(c, a[i]|a[j]));
    }

    output(n, a);

    delete[] a;
    delete[] b;
    return 0;
}
