#include <iostream>
#include <array>

using Map = std::array<int, 26>;

bool check_input(Map& map, std::string const& input)
{
	auto map_copy = map;
	auto new_character = '\0';

	for (auto const c : input)
	{
		if (map_copy[c - 'A'])
		{
			--map_copy[c - 'A'];
			continue;
		}

		if (new_character != '\0')
			return false;

		new_character = c;
	}

	++map[new_character - 'A'];
	return true;
}

int main()
{
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);

	Map map {{ 0 }};

	int num_inputs;
	std::cin >> num_inputs;

	std::string input;
	input.reserve(num_inputs);

	std::cin >> input;
	map[input[0] - 'A'] = 1;

	bool done = false;
	int i;
	for (i = 1; i < num_inputs; ++i)
	{
		std::cin >> input;
		if (done)
			continue;

		if (!check_input(map, input))
		{
			done = true;
			std::cout << i << '\n';
		}
	}
	if (!done)
		std::cout << i << '\n';
}
