using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SlepiBrojevi
{
    class Program
    {        
        static void Main(string[] args)
        {
            int[] input = GetValues();
            int pocetniBroj = input[0];
            int krajniBroj = input[1];
            int sumaCifara = input[2];
            int proizvodSlepih = input[3];
            SlepBroj slepBroj = null;
            slepBroj =  OdrediSlepeBrojeve(pocetniBroj, krajniBroj, sumaCifara, slepBroj);
            Console.WriteLine(OdrediParove(slepBroj,proizvodSlepih));
            Console.ReadLine();
        }

        static int OdrediParove(SlepBroj slepBroj, int proizvod)
        {
            int suma = 0;
            SlepBroj b = slepBroj;
            while (slepBroj != null) {
                if (slepBroj.vrednost * b.vrednost % proizvod == 0)
                    ++suma;
                b = b.sledeci;
                if (b == null)
                {
                    slepBroj = slepBroj.sledeci;
                    b = slepBroj;
                }
            }
            return suma;
        }

        static SlepBroj Pretraga(int[] broj,int trenutniIndex, int n, int trenutniZbir, int trazeniZbir, int poslednjiIndex, SlepBroj trenutniSlepBroj, int maxVrednost, int minVrednost)
        {
            if(trenutniIndex == n - 1)
            {
                if (trazeniZbir - trenutniZbir < 10)
                {
                    broj[trenutniIndex] = trazeniZbir - trenutniZbir;

                    double vrednost = ArrayToNumber(broj, poslednjiIndex);
                    if (vrednost < maxVrednost && vrednost>minVrednost)
                    {
                        SlepBroj slepBroj = new SlepBroj(vrednost);
                        slepBroj.sledeci = trenutniSlepBroj;
                        trenutniSlepBroj = slepBroj;                        
                    }
                    broj[trenutniIndex] = 0;
                }
            }
            else
            {
                int startBroj = 9;
                if (broj[trenutniIndex] != 0) startBroj = broj[trenutniIndex];
                else if(trazeniZbir - trenutniZbir<9) startBroj = trazeniZbir - trenutniZbir;                

                for (int i = startBroj; i > -1; --i)
                {
                    if (trenutniZbir + i <= trazeniZbir)
                    {
                        broj[trenutniIndex] = i;
                        trenutniSlepBroj = Pretraga(broj, trenutniIndex + 1, n, trenutniZbir + i, trazeniZbir, poslednjiIndex, trenutniSlepBroj, maxVrednost, minVrednost);
                        broj[trenutniIndex] = 0;
                    }
                }
            }
            return trenutniSlepBroj;
        }

        static SlepBroj OdrediSlepeBrojeve(int start, int end, int suma, SlepBroj slepBroj)
        {            
            int[] broj = new int[end.ToString().Length];
            int lastIndex = 0;
            PretvoriUNiz(ref broj, end, ref lastIndex);
            int zbirCifara = ZbirCifara(broj, lastIndex);
            return Pretraga(broj, 0,broj.Length, 0, suma, lastIndex, slepBroj, end,start);           
        }


        static void PretvoriUNiz(ref int[] niz, int broj, ref int lastIndex)
        {
            int i = niz.Length - 1;
            while(broj!=0)
            {
                niz[i--] = broj % 10;
                broj /= 10;
            }
            lastIndex = i + 1;
        }

        static double ArrayToNumber(int[] array, int n)
        {
            double vrednost = 0;
            for (int i = n; i < array.Length; i++)
            {
                vrednost += array[i] * Math.Pow(10, array.Length - i - 1);
            }
            return vrednost;
        }

        static int ZbirCifara(int[] broj, int lastIndex)
        {
            int zbir = 0;
            for (int i = broj.Length - 1; i > lastIndex; --i)
            {
                zbir += broj[i];
            }
            return zbir;
        }

        static int[] GetValues()
        {
            string[] input = Console.ReadLine().Split(' ');
            int[] array = new int[input.Length];
            for (int i = 0; i < input.Length; ++i)
            {
                array[i] = int.Parse(input[i]);
            }
            return array;
        }        
    }

    class SlepBroj
    {
        public double vrednost { get; set; }
        public SlepBroj sledeci { get; set; } 

        public SlepBroj(double vrednost)
        {
            this.vrednost = vrednost;          
        }        
    }
}
