#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

inline unsigned long long calculateSum(unsigned int array[], unsigned int mod, unsigned int n, unsigned int l)
{
	unsigned long long sum = 0;
	for (unsigned short i = mod; i < n; i += l)
	{
		sum += array[i];
	}

	return sum;
}

inline unsigned long long sameComs(unsigned int array[], unsigned int groupNumber1, unsigned int groupNumber2, unsigned int l, unsigned int n, unsigned int arr1[], unsigned int arr2[], unsigned int j1, unsigned int j2)
{

	unsigned int count1[10000000] = { 0 };
	unsigned int count2[10000000] = { 0 };
	bool counted[10000000] = { false };

	unsigned long long ret = 0;

	
	if (j1 < j2)
	{
		for (unsigned int i = 0; i < j1; ++i)
		{
			if (!counted[arr1[i]])
			{
				counted[arr1[i]] = true;
				count1[arr1[i]] = count(arr1, arr1 + j1, arr1[i]);
				count2[arr1[i]] = count(arr2, arr2 + j2, arr1[i]);
			}
		}

		for (unsigned int i = 0; i < j2; ++i)
		{
			if (!counted[arr2[i]])
			{
				counted[arr2[i]] = true;
				count2[arr2[i]] = count(arr2, arr2 + j2, arr2[i]);
			}
		}
	}
	if (j1 > j2)
	{
		for (unsigned int i = 0; i < j1; ++i)
		{
			if (!counted[arr2[i]])
			{
				counted[arr2[i]] = true;
				count1[arr2[i]] = count(arr2, arr2 + j2, arr2[i]);
				count2[arr1[i]] = count(arr1, arr1 + j1, arr2[i]);
			}
		}

		for (unsigned int i = 0; i < j1; ++i)
		{
			if (!counted[arr1[i]])
			{
				counted[arr1[i]] = true;
				count1[arr1[i]] = count(arr1, arr1 + j1, arr1[i]);
			}
		}
	}

	if (j1 == j2)
	{
		for (unsigned int i = 0; i < j1; ++i)
		{
			if (!counted[arr2[i]])
			{
				counted[arr2[i]] = true;
				count1[arr2[i]] = count(arr2, arr2 + j2, arr2[i]);
				count2[arr1[i]] = count(arr1, arr1 + j1, arr2[i]);
			}
		}
	}

	for (unsigned long long i = 0; i < 1000; ++i)
		ret += count1[i] * count2[i];
	return ret;
}

inline unsigned long long checkComs(unsigned int array[], unsigned long long groupSums[], unsigned int groupNumber1, unsigned int groupNumber2, unsigned int l, unsigned int n)
{
	unsigned long long coms = 0;
	unsigned int arr1[10000000];
	unsigned int arr2[10000000];
	unsigned int j1;
	unsigned int j2;
	for (unsigned int i = groupNumber1, j = 0; i < n; i += l, ++j, j1 = j)
		arr1[j] = array[i];
	for (unsigned int i = groupNumber2, j = 0; i < n; i += l, ++j, j2 = j)
		arr2[j] = array[i];

	if (abs(long long(groupSums[groupNumber1] - groupSums[groupNumber2])) % 2 == 0)
	{
		unsigned int diff = abs(long long(groupSums[groupNumber1] - groupSums[groupNumber2])) / 2;

		if (groupSums[groupNumber1] < groupSums[groupNumber2])
		{
			for (unsigned int i = 0; i < j1; ++i)
			for (unsigned int j = 0; j < j2; ++j)
			{
				if ((int(arr2[j]) - int(arr1[i])) == diff) ++coms;
			}

		}

		if (groupSums[groupNumber2] < groupSums[groupNumber1])
		{
			for (unsigned int i = 0; i < j1; ++i)
			for (unsigned int j = 0; j < j2; ++j)
			{
				if ((int(arr1[i]) - int(arr2[j])) == diff) ++coms;
			}

		}
	}
	
	else coms += sameComs(array, groupNumber1, groupNumber2, l, n, arr1, arr2, j1, j2);

	return coms;
	}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	unsigned int n, l;
	cin >> n >> l;
	unsigned int array[10000000];
	unsigned long long groupSums[100000000];

	for (unsigned int i = 0; i < n; ++i)
		cin >> array[i];

	for (unsigned int i = 0; i < l; ++i)
		groupSums[i] = calculateSum(array, i, n, l);
	
	unsigned long long combinations = 0;

	for (unsigned int i = 0; i < l; ++i)
	for (unsigned int j = i + 1; j < l; ++j)
		combinations += checkComs(array, groupSums, i, j, l, n);

	cout << combinations << endl;

	return 0;


}