using System;
using System.Collections.Generic;


namespace LukaKostic_Takmicenje
{
    class Program
    {
        struct broj
        {
            public int index;
            public int vrednost;
        }

        class grupa
        {
            public List<broj> brojevi;

            public grupa()
            {
                brojevi = new List<broj>();
            }

            public int CalcSuma()
            {
                int suma = 0;
                for (int i = 0; i < brojevi.Count; i++) suma += brojevi[i].vrednost;
                return suma;
            }
        }

        struct nacin
        {
            public int i;
            public int j;
        }

        static void Switch(ref grupa[] grupe, int a, int b, ref List<nacin> nacini)
        {
            broj temp1;
            broj temp2;

            for (int i1 = 0; i1 < grupe[a].brojevi.Count; i1++)
            {
                for (int i2 = 0; i2 < grupe[b].brojevi.Count; i2++)
                {
                    if (i1 >= i2) continue;

                    temp1 = grupe[a].brojevi[i1];
                    temp2 = grupe[b].brojevi[i2];

                    grupe[a].brojevi[i1] = temp2;
                    grupe[b].brojevi[i2] = temp1;

                    bool same = true;
                    int suma = grupe[0].CalcSuma();
                    for (int i = 1; i < grupe.Length; i++)
                    {
                        if (grupe[i].CalcSuma() != suma)
                        {
                            same = false; break;
                        }
                    }

                    if (same) // && nacini.Contains(new nacin { i = i1, j = i2 }) == false
                    {
                        nacini.Add(new nacin { i = i1, j = i2 });
                    }

                    grupe[a].brojevi[i1] = temp1;
                    grupe[b].brojevi[i2] = temp2;
                }
            }
        }

        static int Main(string[] args)
        {
            int n, l, i, i1, i2, t, g;

            string[] NiL = Console.ReadLine().Split(' ');
            n = int.Parse(NiL[0]);
            l = int.Parse(NiL[1]);
            //1 <= L <= N

            string[] sliced = Console.ReadLine().Split(' ');

            int[] a = new int[n];
            for (i = 0; i < n; i++)
            {
                a[i] = int.Parse(sliced[i]);
            }


            grupa[] grupe = new grupa[l];
            for (i = 0; i < n; i++)
            {
                g = i % l;


                if (grupe[g] == null || grupe[g].brojevi == null)
                    grupe[g] = new grupa();


                grupe[g].brojevi.Add(new broj { index = i, vrednost = a[i] });

            }

            List<nacin> nacini = new List<nacin>();

            //Check if inside group is switchable
            for (g = 0; g < l; g++)
                Switch(ref grupe, g, g, ref nacini);

            //Cross check group
            for (i1 = 0; i1 < l; i1++)
                for (i2 = 0; i2 < l; i2++)
                    if (i1 != i2) Switch(ref grupe, i1, i2, ref nacini);

            Console.Write(nacini.Count);


            return 0;

        }
    }
}

//1 5 3 3
//1 2 3 4
//x o x o
//x = 4
//o = 8

//3 5 3 1
//1 2 3 4
//x o x o
//x = 6
//o = 6

//1 3 5 3
//1 2 3 4
//x o x o
//x = 6
//o = 6

//1 2 3 4 5 6
//x o x o x o

//x = 9
//o = 12


//1 2 3 4 3 5
//x o x o x o

//x = 9
//o = 9

//1 4 6 2 3 5
//a b c a b c

//a = 3
//b = 7
//c = 11

//1 4 2 6 3 5
//a b c a b c

//a = 7
//b = 7
//c = 7

